function [Chk_H,temp1,temp2]=PEG_generate(N_bits,m_Chks,lamda,rou)

% PEG Algorithm for Generating Parity-Check matrix (H)

% Warning : The input lamda and rou are vectors, not polynomials!
% lamda   : Variable Node Polynomial Distribution
% rou     : Check Node Polynomial Distribution
% N_bits  : Number of Variable Nodes (N)
% m_Chks  : Number of Check Nodes (M)

% Chk_H   : Parity Check Matrix(H)
% temp1   : The integral of lamda distribution in the domain =[0,1]
% temp2   : The integral of rou distribution in the domain =[0,1]
%
%
% Adapted by Pedro Abdalla Teixeira

%BitNode_poly=sym2poly(lamda); 
%ChkNode_poly=sym2poly(rou);
BitNode_poly=lamda;
ChkNode_poly=rou;
BitNode_poly=BitNode_poly(end:-1:1);
ChkNode_poly=ChkNode_poly(end:-1:1);
lamda=poly2sym(lamda);
rou=poly2sym(rou);
Nv=[];
Nc=[];
Ds=[];
%tannerͼþʾ,ĽڵΪ'0'ʾӦıû,1ʾ
pre_tanner=zeros(m_Chks,N_bits);
D_chk=zeros(1,m_Chks);%Ķ
% Computing the Integral of lamda and rou polynomial distribution
temp1=int(lamda,0,1);
temp2=int(rou,0,1);

if (isempty(Nv)==1)
    for j=1:length(BitNode_poly)
        Nv(j)=round(double(N_bits*BitNode_poly(j)/j/temp1));
    end
    
    for j=1:length(ChkNode_poly)
        Nc(j)=round(double(m_Chks*ChkNode_poly(j)/j/temp2));
    end
    
    if sum(Nv)~=N_bits
        Nv(end)=N_bits-sum(Nv(1:end-1));
    end
    
    if sum(Nc)~=m_Chks
        Nc(end)=m_Chks-sum(Nc(1:end-1));
    end
end

for kk=1:length(Nv)
    Ds=[Ds,kk*ones(1,Nv(kk))];
end



%tannerͼþʾ,ĽڵΪ'0'ʾӦıû,1ʾ
%pre_tanner=zeros(m_Chks,N_bits);
%D_chk=zeros(1,m_Chks);%Ķ

% tic
for j=1:N_bits
    for k=1:Ds(j)
        if k==1
            [m_value,m_index]=min(D_chk);
            pre_tanner(m_index,j)=1;
            D_chk(m_index)=D_chk(m_index)+1;
        else %ͼ˼ǰĿǰtannerͼԵjؽڵΪչ
            %һ:
            N_sj=find(pre_tanner(:,j));%L
            N_sj_pi=setdiff(1:m_Chks,N_sj);
            
            while(~isempty(N_sj_pi))%
                N_sj_pi_pre=N_sj_pi;
                Depth_chks=[];%洢Lļڵ
                for kk=1:length(N_sj);
                    temp_bits=find(pre_tanner(N_sj(kk),:));%ҳһkkбؽڵ
                    for nn=1:length(temp_bits)%ҳtemp_bitsnnؽڵм
                        temp_chks=find(pre_tanner(:,temp_bits(nn)));
                        Depth_chks=union(Depth_chks,temp_chks);
                    end
                end
                N_sj=Depth_chks;
                N_sj_pi=setdiff(1:m_Chks,N_sj);
                
                if length(N_sj_pi)==length(N_sj_pi_pre)%N_sj_pi
                    break;
                end
                
            end
            
            temp_D_chk=D_chk(N_sj_pi_pre);
            [m_value,m_index]=min(temp_D_chk);
            pre_tanner(N_sj_pi_pre(m_index),j)=1;
            D_chk(N_sj_pi_pre(m_index))=D_chk(N_sj_pi_pre(m_index))+1;
        end%ifk==1
    end%k=1:Ds(j)
end%j=1:N_bits

Chk_H=pre_tanner;

% 
% time_elapse=toc



% save PEG_Chk Chk_H lamda rou N_bits m_Chks Nv time_elapse
% 
% % !shutdown -s
            
            

